
from piscript.PiModule import *

import math

A = math.pi/3
ell = 3
lw = 0.5

shift = 20

P = [
	[-ell*math.sin(A/2), -ell*math.cos(A/2) ],
	[0,0],
	[ ell*math.sin(A/2), -ell*math.cos(A/2) ],
]


h = lw/(math.sin(A/2))

init("miter", 120+2*shift, 120)

beginpage()
gsave()
center()
translate(-shift, 27)
scale(29)
setlinejoin(2)

dx = lw*math.cos(A+math.pi/2)
dy = lw*math.sin(A+math.pi/2)
Q = [ 
	[ P[0][0]+dx, P[0][1]+dy ],
	[ P[0][0]-dx, P[0][1]-dy ],
	[ P[1][0], P[1][1]-h],
	[ P[2][0]+dx, P[2][1]-dy ],
	[ P[2][0]-dx, P[2][1]+dy ],
	[ P[1][0], P[1][1]+h],
]

rad=0.64

gsave()
translate(Q[2])
rotate(-math.pi/2)
newpath()
moveto(0,0)
arc(0,0,rad,-A/2, A/2)
fill(0.8)
stroke()
grestore()

gsave()
newpath()
moveto(Q[5])
lineto(Q[2])
moveto(Q[2])
rlineto(2*dx, 2*dy)
stroke(0.7)
grestore()

gsave()
setdash([0.125,0.125], 0.0)
newpath()
moveto(2.0,h)
rlineto(-2.0,0)
moveto(2.0,-h)
rlineto(-2.0,0)
stroke(0.7)
grestore()

gsave()
translate(2.0, 0)
sw = 0.064
hw = 3.6*sw
setarrowdims(sw, hw)
newpath()
openarrow(0, 0.96*h)
openarrow(0,-0.96*h)
fill(0.7)
grestore()


newpath()
moveto(P[0])
lineto(P[1])
lineto(P[2])
stroke(0.8,0,0)

newpath()
moveto(Q[0])
lineto(Q[1])
lineto(Q[2])
lineto(Q[3])
lineto(Q[4])
lineto(Q[5])
closepath()
stroke(0,0,0)

grestore()

gsave()
translate(60,60)
translate(-3, -15)
t = texinsert("$\\alpha$")
place(t)
grestore()

gsave()
translate(125,93)
t = texinsert("miter")
place(t)
grestore()

gsave()
translate(125,81)
t = texinsert("length")
place(t)
grestore()
endpage()
finish()
