# from piscript.PiScript import PiScript
from piscript.Path import *

import math	

def arc(ps, *args):
	if len(args) == 4:
		x = args[0][0]
		y = args[0][1]
		r = args[1]
		A = args[2]
		B = args[3]
	else:
		x = args[0]
		y = args[1]
		r = args[2]
		A = args[3]
		B = args[4]
	Ax = A*ps.toRad
	Bx = B*ps.toRad
	
	while Bx < Ax:
		Bx += 2*math.pi
	p = math.pi/2
	if ps.currentpoint():
		ps.lineto(x + r*math.cos(Ax), y + r*math.sin(Ax))
	else:
		ps.moveto(x + r*math.cos(Ax), y + r*math.sin(Ax))
	while Bx-Ax > p:
		makesimplearc(ps, x, y, r, Ax, Ax+p)
		Ax += p
	if not abs(Ax-Bx) < 0.000000001:
		makesimplearc(ps, x, y, r, Ax, Bx)

def absarc(ps, *args):
	x = args[0]
	y = args[1]
	r = args[2]
	A = args[3]
	B = args[4]
	
	while B < A:
		B += 2*math.pi
	p = math.pi/2
	if ps.currentpoint():
		ps.lineto(x + r*math.cos(A), y + r*math.sin(A))
	else:
		ps.moveto(x + r*math.cos(A), y + r*math.sin(A))
	while B-A > p:
		makesimplearc(ps, x, y, r, A, A+p)
		A += p
	if not abs(A-B) < 0.000000001:
		makesimplearc(ps, x, y, r, A, B)


# assumes initial point = current point
# touches the mid-point of the arc
def makesimplearc(ps, x, y, r, A, B):	
	dA = 0.5*(B-A)
	dx = r*math.cos(dA)
	dy = r*math.sin(dA)
	c = 4*(r-dx)/(3.0*dy)
	dx0 = r*math.cos(A)
	dy0 = r*math.sin(A)
	dx3 = r*math.cos(B)
	dy3 = r*math.sin(B)
	P0 = [ x + dx0, y + dy0 ]
	P3 = [ x + dx3, y + dy3 ]
	P1 = [ P0[0] - c*dy0, P0[1] + c*dx0 ]
	P2 = [ P3[0] + c*dy3, P3[1] - c*dx3 ]
	ps.curveto(P1, P2, P3)

def arcn(ps, *args):
	if len(args) == 4:
		x = args[0][0]
		y = args[0][1]
		r = args[1]
		A = args[2]
		B = args[3]
	else:
		x = args[0]
		y = args[1]
		r = args[2]
		A = args[3]
		B = args[4]
	Ax = A*ps.toRad
	Bx = B*ps.toRad
	while Ax < Bx:
		Ax += 2*math.pi
	p = math.pi/2
	if ps.currentpoint():
		ps.lineto(x + r*math.cos(Ax), y + r*math.sin(Ax))
	else:
		ps.moveto(x + r*math.cos(Ax), y + r*math.sin(Ax))
	while Ax - Bx > p: # A-p > B
		makesimplearc(ps, x, y, r, Ax, Ax-p)
		Ax -= p
	if not abs(A-B) < 0.000000001:
		makesimplearc(ps, x, y, r, Ax, Bx)

		
def circle(ps, *args):
	if len(args) == 1:
		x = 0
		y = 0
		r = args[0]
	elif len(args) == 2:
		x = args[0][0]
		y = args[0][1]
		r = args[1]
	else:
		x = args[0]
		y = args[1]
		r = args[2]
	absarc(ps, x, y, r, 0, math.pi/2)
	absarc(ps, x, y, r, math.pi/2, math.pi)
	absarc(ps, x, y, r, math.pi, 3*math.pi/2)
	absarc(ps, x, y, r, 3*math.pi/2, 2*math.pi)
	ps.closepath()


