
from piscript.PiScript3d import Face, ConvexSurface

class Cube(ConvexSurface):
	v = [
		[-1,-1,-1],
		[-1, 1,-1],
		[ 1, 1,-1],
		[ 1,-1,-1],
		[-1,-1, 1],
		[-1, 1, 1],
		[ 1, 1, 1],
		[ 1,-1, 1]
	]
	p = [
		[ v[0], v[1], v[2], v[3] ],
		[ v[4], v[5], v[6], v[7] ],
		[ v[0], v[1], v[5], v[4] ],
		[ v[1], v[2], v[6], v[5] ],
		[ v[2], v[3], v[7], v[6] ],
		[ v[3], v[0], v[4], v[7] ]
	]

	def __init__(self, c):
		f = []
		for i in range(6):
			nf = Face.normalfunction(Cube.p[i])
			if nf[3] > 0:
				f.append(Face(Face.reverse_array(Cube.p[i]), c))
			else:
				f.append(Face(Cube.p[i], c))
		
		ConvexSurface.__init__(self, f)

