import re
"""
import logging
"""
import FontMap
import Type1

try:
	import pykpse
	find=pykpse.find
	formats=pykpse
	# print "Using pykpse!"
except:
	import kpsewhich
	find=kpsewhich.find
	formats = kpsewhich
	# print "Using kpsewhich!"

vfPathCache={}
def getVF(fn):
	fontPath = vfPathCache.get(fn,None)
	if not fontPath:
		fontPath = find(fn, formats.VF_TYPE)
		vfPathCache[fn] = fontPath
	return fontPath

tfmPathCache = {}
def getTFM(fn):
	fontPath = tfmPathCache.get(fn,None)
	if not fontPath:
		fontPath = find(fn, formats.TFM_TYPE)
		tfmPathCache[fn] = fontPath
	return fontPath

type1Cache = {}
def type1FontForPath( fontPath ):
	t1font = type1Cache.get( fontPath, None )
	if not t1font:
		t1font = Type1.Type1Font( fontPath )
		type1Cache[fontPath] = t1font
	return t1font

pfbPathCache = {}
def getPFB(fn):
	fontPath = pfbPathCache.get(fn, None)
	if not fontPath:
		fontPath = find(fn, formats.TYPE1_TYPE)
		pfbPathCache[fn] = fontPath
	return fontPath

# Encoding file resources

def getEncoding(e):
  return find(e, formats.ENC_TYPE)

# Map file resources

mapFileDict = {}

def getMapFile(m):
	mf = mapFileDict.get(m, None)
	if not mf:
		p = getMapFilePath( m )
		if not p:
			return None
		mf = FontMap.FontMap( p )
		mapFileDict[m] = mf
	return mf

def getMapFilePath(m):
	p = find(m, formats.FONTMAP_TYPE)
	return p
