#!/usr/bin/python

from Fstr import fstr

from DviReader import *
import DeviceFont
import FindResource
from Tex import TexEnv
from PysCmdDevice import PysCmdDevice
import Tex

from Canvas import *

""" from StringInsert import StringInsert
from Arc import *
from Matrix import Matrix
from Tex import * # imports Canvas, too
from StringInsert import *
from Graphics import *
from CMRFontDict import *
from StdFontDict import * """

import math
import sys

"""
	init arguments:

	Currently:
		w, h
		llx, lly, urx, ury - filename = present file + .eps
		extension, w, h
		extension, llx, lly, urx, ury - filename = present file + extension
		filename, w, h
		filename, llx, lly, urx, ury: 

	Future: 
		filename, no dims - bbox found by computation: init() possible

	if args[0] is a string: filename or extension, rest = 2 or 4 numbers
	else: args[0] = a number, 2 or 4 args
	
"""

class PageData:
	# level = level of corresponding graphics stack
	def __init__(self, cmd, level):
		c = []
		for i in range(len(cmd)):
			c.append(cmd[i])
		self.cmd = c
		self.level = level

class PiScript(Canvas):
	# FIXME: extension determines kind of output (now .eps, .ps & later .pdf)
	# mode 0 = radians, 1 = degrees
	def __init__(self, device, *Args):
		args = []
		for a in Args:
			args.append(a)
		cliptobbox = True
		if type(args[-1]) == str:
			if args[-1] == "noclip":
				cliptobbox = False
			args.pop()
		# --- sets filename, extension (.ps or .eps [default]) & bounding box ------------------
		if len(args) > 0:
			a = args[0]
			if type(a) == str:
				if a == ".ps" or a == ".eps":
					self.ext = a
					filename = sys.modules['__main__'].__file__
					filename = filename[:-3] # drop the .py
				elif a[-3:] == ".ps":
					filename = a[:-3] # drop the .ps
					self.ext = ".ps"
				elif a[-4:] == ".eps":
					filename = a[:-4] # drop the .eps
					self.ext = ".eps"
				else:
					filename = a 
					self.ext = ".eps" # default extension
				if len(args) == 3:
					self.llx = 0
					self.lly = 0
					self.urx = int(args[1])
					self.ury = int(args[2])
				else: # len = 5
					self.llx = int(args[1])
					self.lly = int(args[2])
					self.urx = int(args[3])
					self.ury = int(args[4])
			else: # a number
				filename = sys.modules['__main__'].__file__
				if filename[-3:] == ".py":
					filename = filename[:-3] # drop the .py
				else:
					print "Expecting source file with .py extension"
					print "Exiting ... "
					sys.exit(1)
				self.ext = ".eps"
				if len(args) == 2:
					self.llx = 0
					self.lly = 0
					self.urx = int(args[0])
					self.ury = int(args[1])
				else: # len = 4
					self.llx = int(args[0])
					self.lly = int(args[1])
					self.urx = int(args[2])
					self.ury = int(args[3])
		else:
			print "No arguments for init!"
			print "Exiting ... "
			sys.exit(1)
		# -------------------------------------------------------------------

		Canvas.__init__(self)
		self.bbox = [self.llx, self.lly, self.urx, self.ury]

		# -------------------------------------------------------

		print "Initializing " + filename + self.ext
		self.filename = filename

		self.device = device;

		# -------------------------------------------------------
		print "Bounding box: ", [ self.llx, self.lly, self.urx, self.ury ]
		w = self.urx-self.llx
		h = self.ury-self.lly
		self.width = w
		self.height = h
		device.setbbox([ self.llx, self.lly, self.urx, self.ury ])
		# ------------------------------------------------------
		self.settexenv("TexConfig")
		self.insertno = 0 # for labeling saved inserts
		# ------------------------------------------------------

		self.pageno = 0
		self.pagestring = ""
		self.pagestack = [ PageData( [], self.glevel) ]
		self.beginpage()

		self.setlinewidth(1)
		self.setlinecap(0)
		self.setlinejoin(0)
		self.setdash([], 0)
		self.setmiterlimit(10.0)
		self.setcolor([0,0,0])
		if cliptobbox:
			self.newpath()
			self.boundedbox(self.bbox)
			self.clip()

		self.endblock = True


	# =================================================================

	def currentcenter(self):
		gs = self.cgs()
		b = self.bbox
		x = 0.5*(b[0]+b[2])
		y = 0.5*(b[1]+b[3])
		return gs.transform((x, y))

	def currentbbox(self):
		b = self.bbox
		gs = self.cgs()
		ll = gs.transform((b[0], b[1]))
		lr = gs.transform((b[2], b[1]))
		ur = gs.transform((b[2], b[3]))
		ul = gs.transform((b[0], b[3]))
		
		return [ ll, lr, ur, ul ]
	
	# ===================================================================================

	def center(self):
		b = self.bbox
		x = 0.5*(b[0]+b[2])
		y = 0.5*(b[1]+b[3])
		self.translate(x, y)

	def beginpage(self, *args):
		self.pagestring += "("
		opd = self.pagestack[-1]
		pd = PageData(opd.cmd, opd.level)
		self.pagestack.append(pd)
		self.cmd = pd.cmd
		self.gsave()

	def endpage(self):
		n = len(self.pagestack)
		if self.endblock and n == 2:
			print "Oops!  You are attempting to finish prematurely!"
			print "Now exiting ... !"
			sys.exit(1)
		# --- check graphics stack --------------------------------------
		ell1 = self.glevel
		ell0 = self.baselevel()+1
		ell = ell1-ell0
		if not ell == 0:
			print
			if ell < 0:
				print "WARNING! ====== There is an extra grestore! ====== "
			else: # ell > 0:
				print
				if ell > 1:
					print "WARNING! ====== There are " + str(ell) + " too many gsaves! ====== "
				else: # ell = 1
					print "WARNING! ====== There is an extra gsave! ====== "
			print "=============== Restoring to base! ====== "
		for i in range(ell+1):
			self.grestore()

		# --------------------------------------------------------------
		# something funny we did about not needing begin page?
		if self.pagestring[-1] == "(":
			self.device.writePage( self )
			self.pageno += 1
			print "[" + str(self.pageno) + "]",
		self.pagestring += ")"
		self.pagestack.pop()
		pd = self.pagestack[-1]
		self.cmd = pd.cmd

	def finish(self):
		self.endblock = False
		self.endpage()
		finalout = open( self.filename+self.ext, "w" )
		self.device.finish( finalout, toEPS = (self.ext=='.eps') )
		finalout.close()

	# FIXME: WAC, return in currentcoords
	def currentbbox(self):
		gs = self.cgs()
		return ( 
			gs.itransform((self.llx, self.lly)), 
			gs.itransform((self.urx, self.lly)), 
			gs.itransform((self.urx, self.ury)), 
			gs.itransform((self.llx, self.ury))
		)

	def baselevel(self):
		opd = self.pagestack[-2]
		return opd.level

	def gsave(self):
		pd = self.pagestack[-1]
		pd.level += 1
		Canvas.gsave(self)

	def grestore(self):
		ell0 = self.baselevel()
		ell1 = self.glevel
		if ell1 > ell0:
			Canvas.grestore(self)
			pd = self.pagestack[-1]
			pd.level -= 1
		else:
			print "WARNING! too many grestores!"
			

	# ============================================================

	def settexprefix(self, s):
		self.texenv.setprefix(s)

	def settexpostfix(self, s):
		self.texenv.setpostfix(s)

	def settexcommand(self, s):
		self.texenv.setcommand(s)

	def settexsave(self, save):
		self.texenv.setsave(save)

	"""
		Either one argument or 3 +                                                                                          
		if 3, then strings = prefix, command, postfix
		if 1, then
			"plain"
			"latex"
			None
			filename like "PSTexConfig": checks locally, then goes global
	"""

	def settexenv(self, *args):

		if len(args) == 1: # arg[0] = "plain" or "latex" or TexConfig file name
			if args[0] == "plain":
				cfgfile = "PlainTexConfig"
			elif args[0] == "latex":
				cfgfile = "LaTexConfig"
			else:
				cfgfile = args[0]
			# so now cgffile is the prefix of a TexConfig file
			# -------------------------------------------------------
			# check current directory, 
			# then personal cfg dir, 
			# then normal PYS directory
			cfg = os.getcwd()
			cfgpathname = os.path.join(cfg, cfgfile + ".py")
			if os.path.exists(cfgpathname):
				print "importing local " + cfgpathname
				
				f = open(cfgpathname, "r")
				r = f.read()
				exec(r)
				self.texenv = getTexEnv()

				"""
				print "------------------------"
				exec "import " + cfgfile
				self.texenv = eval(cfgfile + ".getTexEnv()")
				print "------------------------" 
				"""

				return
			# -------------------------------------------------------
			if os.environ.has_key("LOCALPISCRIPTDIR"):
				cfg = os.environ["LOCALPISCRIPTDIR"]
				home = os.getenv("HOME")
				import re
				m = re.search("(\$HOME)", cfg)
				X = re.subn("\$HOME", home, cfg)
				cfg = X[0]
				if cfg:
					cfgpathname = os.path.join(cfg, "configs", cfgfile + ".py")
					if os.path.exists(cfgpathname):
						print "importing home " + cfgpathname

						f = open(cfgpathname, "r")
						r = f.read()
						exec(r) 
						self.texenv = getTexEnv()

						"""
						exec "import configs." + cfgfile 
						print "importing " + cfgpathname
						self.texenv = eval("configs." + cfgfile + ".getTexEnv()")
						"""
						return
			# -------------------------------------------------------
			cfg = os.path.abspath(os.path.dirname(__file__))
			cfgpathname = os.path.join(cfg, cfgfile + ".py")
			if os.path.exists(cfgpathname):
				print "importing global " + cfgpathname

				f = open(cfgpathname, "r")
				r = f.read()
				exec(r) 
				self.texenv = getTexEnv()
				"""
				exec "import piscript." + cfgfile 
				print "importing " + cfgpathname
				self.texenv = eval("piscript." + cfgfile + ".getTexEnv()")
				"""
				return
			# -------------------------------------------------------
			print "WARNING! TEX configuration ", cfgfile, " not found!"
			print "?", cfgpathname
			print "Aborting mission!"
			import sys
			sys.exit(1)
		else: # prefix, command, postfix
			self.texenv = TexEnv(*args)

	def stringinsert(self, s):
		c = StringInsert(s)
		return c

	# args = (texstring), (texstring, save/not)
	def texinsert(self, *args):
		texstring = args[0]
		s = None
		if len(args) == 1:
			if self.texenv.save == True:
				s = "tmp-" + self.filename + "-" + str(self.insertno)  # tex label
				self.insertno += 1
		else:
			if type(args[1]) == bool and args[1] == True:
				s = "tmp-" + self.filename + "-" + str(self.insertno)  # tex label
				self.insertno += 1
			else: # string = name to be saved by
				s = "tmp-" + self.filename + "-" + args[1] # tex label
		# the 792 is because TEX is set up for North America ... ?  If in Europe? WAC: FIXME
		tr = Tex.TexRunner( self.texenv,  texstring, PysCmdDevice(792, self.currentcolor()), saveLabel=s )
		T = tr.device.pages[0]
		return T


